clear all;
% Nastaveni vlasnosti zobrazovane latky - casu T1 a T2
t1 = 0.5; %[s]
t2 = .5; %[s]

% Nastaveni uhlu RF pulsu
pulseAngle = pi/2; %[radian]
refocus = pi;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NEMENIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Tpulse = 1e-5;
Trelax = .04;
% Nastaveni pulsni sekvence
b_flip = [zeros(1,50) sinc(-pi:pi/25:pi) zeros(1,50)];
b_refocus = [zeros(1,50) sinc(-pi:pi/25:pi) zeros(1,50)];

% pulse + refocus + fill
t_len = 151 + 151 + 100;
tp_len = 2 * 151;
% Nastaveni gradientu ve smeru x
g  = [zeros(1,t_len) zeros(1,100)];

% Casy, ve kterych plati nasteveni pulsu a gradientu
t = [ones(1,tp_len)*Tpulse ones(1,100)*Trelax];
tP  = Tpulse*(0:tp_len);
tP  = [tP (max(tP)+0.00001+(1:100)*Trelax)];

% Nastaveni sily pulsu, tak aby byl vyslan puls otacejici vektor
% magnetizace M0 o prislusny uhel
b1a = pulseAngle*b_flip/max(b_flip)/2.24;
b2a = refocus*b_refocus/max(b_refocus)/2.24;

b1 = [b1a b2a zeros(1, 100)];

[mx,my,mz] = bloch(b1,g,t,t1,t2,0,0,2,0,0,1);

% Vykresleni vektoru magnetizace ve smeru x a z pro dany excitovany bod
figure();
subplot(121);
plot(tP(1:tp_len)*1e3,mx(1:tp_len,1,1),'r',tP(1:tp_len)*1e3,mz(1:tp_len,1,1),'b');
xlabel('Cas [ms]'); ylabel('Magnetizace'); 
title('Magnetizace behem pusobeni RF pulsu');
legend('Mxy','Mz'); grid on;
subplot(122);
plot(tP*1e3,mx(:,1,1),'r',tP*1e3,mz(:,1,1),'b');
xlabel('Cas [ms]'); ylabel('Magnetizace'); 
title('Magnetizace a relaxace po RF pulsu');
legend('Mxy','Mz'); grid on;
